# Makefile
#
# Author: Cristóvão Rufino <czr@cesar.org.br>

CROSS_COMPILE := arm-none-eabi-

CC := $(CROSS_COMPILE)gcc
LD := $(CROSS_COMPILE)gcc
OBJCOPY := $(CROSS_COMPILE)objcopy
OBJCPY_FLAGS += -O binary
NM := $(CROSS_COMPILE)nm
NM_FLAGS += -SCl

# Defining C compiler options
INCLUDEDIR += -I. -I./Drivers/CMSIS/Include \
	-I./Drivers/CMSIS/Device/ST/STM32L0xx/Include \
	-I./Drivers/STM32L0xx_HAL_Driver/Inc -I./Inc -I./Inc/usb \
	-I./Middlewares/ST/STM32_USB_Device_Library/Class/CDC/Inc \
	-I./Middlewares/ST/STM32_USB_Device_Library/Core/Inc
DEFINES += -DSTM32L052xx -DUSE_FULL_ASSERT -DBOARD_SIGFOX -DUSE_DEBUG 
CFLAGS += -mthumb -mcpu=cortex-m0plus -Os -ggdb -Wall -Wextra -MD \
	-ffunction-sections -fdata-sections --std=c99 -c \
	$(INCLUDEDIR) $(DEFINES)
LDFLAGS += -Wl,--gc-sections -T STM32L052R8_FLASH.ld \
	-Wl,--entry=Reset_Handler --specs=nano.specs -mthumb -mcpu=cortex-m0plus -lc -lm -lnosys
LIBS +=

# Defining source-code path
SRC += $(shell find . -type f -name '*.c')
ASM += $(shell find . -type f -name '*.S')

OBJ += $(SRC:.c=.o)
OBJ += $(ASM:.S=.o)

all: $(OBJ)
	$(LD) $(LDFLAGS) $(OBJ) $(LIBS) -o salvus_fw.elf
	$(OBJCOPY) $(OBJCPY_FLAGS) salvus_fw.elf salvus_fw.bin

clean:
	$(RM) $(OBJ)
	$(RM) salvus_fw.elf salvus_fw.bin
	$(RM) $(shell find . -type f -name '*.d')

elf-info:
	$(NM) $(NM_FLAGS) salvus_fw.elf

write:
	st-flash write salvus_fw.bin 0x08000000
